#! /usr/bin/env python
import olpcgames, pygame, logging, random
from pygame import camera

log = logging.getLogger( 'Pointillism run' )
log.setLevel( logging.ERROR )

def main():
    size = (1200,900)
    if olpcgames.ACTIVITY:
        size = olpcgames.ACTIVITY.game_size
    screen = pygame.display.set_mode(size)
    
    screen.fill((0,0,0))
    clock = pygame.time.Clock()
    cam = camera.Camera("/dev/video0", (640, 480), "RGB")
    cam.set_controls(True, False)
    cam.start()
    cap = pygame.surface.Surface((640, 480), 0, 24)
    frames = 0

    running = True
    while running:
        cap = cam.get_image(cap)

        for z in range(max(20, int(frames)*5)):
            x = random.random()
            y = random.random()
            rect = pygame.draw.circle(screen, cap.get_at((int(x * 640), int(y * 480))), (int(x * 1200), int(y * 900)), random.randrange(2, 12, 1), 0)
            pygame.display.update(rect)

        clock.tick()
        frames = clock.get_fps() 

        events = pygame.event.get()       
        if events:
            for event in events:
                log.debug( "Event: %s", event )
                if event.type == pygame.QUIT:
                    running = False
                elif event.type == pygame.KEYDOWN:
                    if event.key == pygame.K_ESCAPE:
                        running = False
            pygame.display.flip()

if __name__ == "__main__":
    logging.basicConfig()
    main()
